/*
 * iDosca.js
 */

var iDosca = function(){
    var Database = Deferred.WebDatabase;
    var DATABASE = new Database("Comiket77", { estimatedSize: 15 * 1024 * 1024 });

    this.database = DATABASE;

    this.log = {
        error : function(val){ $('#log').append('<li class="info" style="color:red">' + val + '</li>') },
        debug : function(val){ $('#log').append('<li class="info">' + val + '</li>') },
    };

    var DoscaTable = function(args,database) {
        var Model = Deferred.WebDatabase.Model;
        var db    = Model(args,database);

        this.__defineGetter__('table', function(){ return db });
    };

    DoscaTable.prototype = {
        createTable : function(){ return this.table.initialize().next(this.table.createTable) },
        dropTable   : function(){ return this.table.initialize().next(this.table.dropTable)   },
        count       : function(){ return this.table.count()                                   },

        search : function(where){ return this.table.find({ where: where }) },

        searchResultInto: function(parent, where, display_condition){
            $('.search_word').text('Loading...');

            return this.search(where)
            .next(function(res){
                parent.empty();
    
                for ( var i = 0; i < res.length; i++ )  {
                    var c = res[i];
    
                    parent.append(
                        '<li id="' + c.id + '" class="arrow"><a href="#circle">'
                        + '<small>' + c.id + '</small>'
                        + '<span class="circle_name">' + c.circle_name + '</span>'
                            + '<em class="circle_author">' + c.circle_author + '</em>'
                            + '<em>'
                                + ' <span>' + c.day + '日目</span>'
                                + ' <span class="circle_hole">' + c.hole + '</span>'
                                + ' <span class="circle_space">' + c.circle_place + '</span>'
                            + '</em>'
                        + '</a></li>'
                    );  
                }   

                $('.search_word').text(display_condition + '(' + res.length + ')');
            })  
            .error(function(e){
                alert(e.message);
                jQTouch.goBack(1);
            }); 
        }, 
    }

    this.Resultsets = {

        SQLITE_MASTER : new DoscaTable({
            table       : 'sqlite_master',
            primaryKeys : [], 
            fields      : { 
                'type'     : 'TEXT',
                'name'     : 'TEXT',
                'tbl_name' : 'TEXT',
                'rootpage' : 'INTEGER',
                'sql'      : 'TEXT'
            }
        },DATABASE),

        Circle : new DoscaTable({
            table       : 'circle',
            primaryKeys : ['id'],
            fields      : {
                'id'            : 'INTEGER PRIMARY KEY',
                'circle_name'   : 'VARCHAR NOT NULL',
                'circle_author' : 'VARCHAR NOT NULL',
                'day'           : 'INTEGER NOT NULL',
                'hole'          : 'VARCHAR NOT NULL',
                'circle_sym'    : 'VARCHAR NOT NULL',
                'circle_num'    : 'INTEGER NOT NULL',
                'circle_flg'    : 'VARCHAR NOT NULL'
            }
        },DATABASE),

    }

    this.Resultsets.Circle.table.prototype.__defineGetter__('circle_place', function(){
        return this.circle_sym + this.circle_num + this.circle_flg;
    });
};

(function(){

    jQuery.fn.autoRegisterEventCallback = function(conf){
        this.each(function(c){
            var id = this.id;
            if ( !id.match(/^run/) )
                return;
    
            id = id.replace(/^run_/, '');
    
            var func = conf[id];
            if ( !func )    {
                alert('function "' + id + '" is not defined');
            }

            $(this).click(func);
        });

        return $(this);
    };

})();
